package cn.ey.biz.module.system.service.category;

import cn.ey.biz.common.pojo.PageResult;
import cn.ey.biz.module.system.api.category.dto.DictCatalogDTO;
import cn.ey.biz.module.system.controller.admin.category.vo.*;
import cn.ey.biz.module.system.dal.dataobject.category.CategoryDataDO;

import javax.validation.Valid;
import java.util.Collection;
import java.util.List;

/**
 * 字典分类数据 Service 接口
 */
public interface CategoryDataService {

    /**
     * 创建字典分类数据
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createCategoryData(@Valid CategoryDataCreateReqVO createReqVO);

    /**
     * 更新字典分类数据
     *
     * @param updateReqVO 更新信息
     */
    void updateCategoryData(@Valid CategoryDataUpdateReqVO updateReqVO);

    /**
     * 删除字典分类数据
     *
     * @param id 编号
     */
    void deleteCategoryData(Long id);

    /**
     * 获得字典分类数据
     *
     * @param id 编号
     * @return 字典分类数据
     */
    CategoryDataDO getCategoryData(Long id);

    /**
     * 获得字典分类数据列表
     *
     * @param ids 编号
     * @return 字典分类数据列表
     */
    List<CategoryDataDO> getCategoryDataList(Collection<Long> ids);

    /**
     * 获得字典分类数据分页
     *
     * @param pageReqVO 分页查询
     * @return 字典分类数据分页
     */
    PageResult<CategoryDataRespVO> getCategoryDataPage(CategoryDataPageReqVO pageReqVO);

    /**
     * 获得字典分类数据列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 字典分类数据列表
     */
    List<CategoryDataDO> getCategoryDataList(CategoryDataExportReqVO exportReqVO);

    /**
     * 根据父ID获取对应的字典数据
     *
     * @Param [pid]
     **/
    List<CategoryDataDO> getCategoryByidData(Long pid);


    /**
     * 获得字典数据列表
     *
     * @return 字典数据全列表
     **/
    List<CategoryDataSimpleRespVO> getCategoryDatas(String app, String acceptLanguage);

    CategoryDataRespVO getCategoryDataByid(Long id);

    CategoryDataDO getCategoryDataKey(String app, String category, String key);
    
    void importDictCatalog(List<DictCatalogDTO> dictCatalogs);
}
